diff --git a/util/nbt/src/main/java/com/mojang/nbt/tags/LongArrayTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/LongArrayTag.java
new file mode 100644
index 000000000..8170d973b
--- /dev/null
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/LongArrayTag.java
@@ -0,0 +1,77 @@
+package com.mojang.nbt.tags;
+
+import org.jetbrains.annotations.NotNull;
+
+import java.io.DataInput;
+import java.io.DataOutput;
+import java.io.IOException;
+import java.nio.ByteBuffer;
+import java.nio.ByteOrder;
+import java.util.Arrays;
+
+public class LongArrayTag extends Tag<long @NotNull []>{
+    public LongArrayTag()
+    {
+        this(new long[0]);
+    }
+
+    public LongArrayTag(long[] array)
+    {
+        super(array);
+    }
+    @Override
+    void write(@NotNull DataOutput dos)
+        throws IOException
+    {
+        dos.writeInt(getValue().length);
+        byte[] bytes = new byte[getValue().length * Long.BYTES];
+        ByteBuffer.wrap(bytes).order(ByteOrder.LITTLE_ENDIAN).asLongBuffer().put(getValue());
+        dos.write(bytes);
+
+    }
+
+    @Override
+    void read(@NotNull DataInput dis)
+        throws IOException
+    {
+        int length = dis.readInt();
+        setValue(new long[length]);
+        byte[] bytes = new byte[length * Long.BYTES];
+        dis.readFully(bytes);
+        ByteBuffer.wrap(bytes).order(ByteOrder.LITTLE_ENDIAN).asLongBuffer().get(getValue());
+    }
+
+    @Override
+    public byte getId() {
+        return TAG_LONG_ARRAY;
+    }
+
+    @Override
+    public String toString()
+    {
+        if (getValue().length > 16)
+        {
+            return "\"" + getTagName() + "\": [ " + getValue().length + " longs ]";
+        }
+        else
+        {
+            StringBuilder sb = new StringBuilder();
+            sb.append("\"").append(getTagName()).append("\": [ ");
+            for (long l : getValue())
+            {
+                sb.append(l).append(", ");
+            }
+            sb.append("]");
+            return sb.toString();
+        }
+    }
+
+    @Override
+    public boolean equals(Object obj) {
+        if(!(obj instanceof LongArrayTag)) return false;
+        LongArrayTag otherTag = (LongArrayTag) obj;
+        long[] thisData = getValue();
+        long[] otherData = otherTag.getValue();
+        return Arrays.equals(thisData, otherData);
+    }
+}
diff --git a/game/core/src/main/java/com/mojang/nbt/LongTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/LongTag.java
similarity index 66%
rename from game/core/src/main/java/com/mojang/nbt/LongTag.java
rename to util/nbt/src/main/java/com/mojang/nbt/tags/LongTag.java
index 61b285a2d..2dd4bc1f7 100644
--- a/game/core/src/main/java/com/mojang/nbt/LongTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/LongTag.java
@@ -1,12 +1,15 @@
-package com.mojang.nbt;
+package com.mojang.nbt.tags;
+
+import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
 
-public class LongTag extends Tag<Long>
+public class LongTag extends Tag<@NotNull Long>
 {
 
     public LongTag()
     {
+        this(0);
     }
 
     public LongTag(long value)
@@ -15,14 +18,14 @@ public class LongTag extends Tag<Long>
     }
 
     @Override
-    void write(DataOutput dos)
+    void write(@NotNull DataOutput dos)
         throws IOException
     {
         dos.writeLong(getValue());
     }
 
     @Override
-    void read(DataInput dis)
+    void read(@NotNull DataInput dis)
         throws IOException
     {
         setValue(dis.readLong());
@@ -31,7 +34,7 @@ public class LongTag extends Tag<Long>
     @Override
     public byte getId()
     {
-        return 4;
+        return TAG_LONG;
     }
 
     @Override
diff --git a/game/core/src/main/java/com/mojang/nbt/ShortArrayTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/ShortArrayTag.java
similarity index 62%
rename from game/core/src/main/java/com/mojang/nbt/ShortArrayTag.java
rename to util/nbt/src/main/java/com/mojang/nbt/tags/ShortArrayTag.java
index 645ce4670..fb202da64 100644
--- a/game/core/src/main/java/com/mojang/nbt/ShortArrayTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/ShortArrayTag.java
@@ -1,15 +1,18 @@
-package com.mojang.nbt;
+package com.mojang.nbt.tags;
+
+import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
 import java.nio.ByteBuffer;
 import java.nio.ByteOrder;
+import java.util.Arrays;
 
-public class ShortArrayTag extends Tag<short[]>
+public class ShortArrayTag extends Tag<short @NotNull []>
 {
 
     public ShortArrayTag()
     {
-        setValue(new short[0]);
+        this(new short[0]);
     }
 
     public ShortArrayTag(short[] array)
@@ -18,23 +21,23 @@ public class ShortArrayTag extends Tag<short[]>
     }
 
     @Override
-    void write(DataOutput dos)
+    void write(@NotNull DataOutput dos)
         throws IOException
     {
         dos.writeInt(getValue().length);
-        byte[] bytes = new byte[getValue().length * 2];
+        byte[] bytes = new byte[getValue().length * Short.BYTES];
         ByteBuffer.wrap(bytes).order(ByteOrder.LITTLE_ENDIAN).asShortBuffer().put(getValue());
         dos.write(bytes);
 
     }
 
     @Override
-    void read(DataInput dis)
+    void read(@NotNull DataInput dis)
         throws IOException
     {
         int length = dis.readInt();
         setValue(new short[length]);
-        byte[] bytes = new byte[length * 2];
+        byte[] bytes = new byte[length * Short.BYTES];
         dis.readFully(bytes);
         ByteBuffer.wrap(bytes).order(ByteOrder.LITTLE_ENDIAN).asShortBuffer().get(getValue());
     }
@@ -42,7 +45,7 @@ public class ShortArrayTag extends Tag<short[]>
     @Override
     public byte getId()
     {
-        return 11;
+        return TAG_SHORT_ARRAY;
     }
 
     @Override
@@ -64,4 +67,13 @@ public class ShortArrayTag extends Tag<short[]>
             return sb.toString();
         }
     }
+
+    @Override
+    public boolean equals(Object obj) {
+        if(!(obj instanceof ShortArrayTag)) return false;
+        ShortArrayTag otherTag = (ShortArrayTag) obj;
+        short[] thisData = getValue();
+        short[] otherData = otherTag.getValue();
+        return Arrays.equals(thisData, otherData);
+    }
 }
diff --git a/game/core/src/main/java/com/mojang/nbt/ShortTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/ShortTag.java
similarity index 65%
rename from game/core/src/main/java/com/mojang/nbt/ShortTag.java
rename to util/nbt/src/main/java/com/mojang/nbt/tags/ShortTag.java
index 41544d710..6a1d17782 100644
--- a/game/core/src/main/java/com/mojang/nbt/ShortTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/ShortTag.java
@@ -1,13 +1,15 @@
-package com.mojang.nbt;
+package com.mojang.nbt.tags;
+
+import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
 
-public class ShortTag extends Tag<Short>
+public class ShortTag extends Tag<@NotNull Short>
 {
 
     public ShortTag()
     {
-        super();
+        this((short) 0);
     }
 
     public ShortTag(short value)
@@ -16,14 +18,14 @@ public class ShortTag extends Tag<Short>
     }
 
     @Override
-    void write(DataOutput dos)
+    void write(@NotNull DataOutput dos)
         throws IOException
     {
         dos.writeShort(getValue());
     }
 
     @Override
-    void read(DataInput dis)
+    void read(@NotNull DataInput dis)
         throws IOException
     {
         setValue(dis.readShort());
@@ -32,7 +34,7 @@ public class ShortTag extends Tag<Short>
     @Override
     public byte getId()
     {
-        return 2;
+        return TAG_SHORT;
     }
 
     @Override
diff --git a/game/core/src/main/java/com/mojang/nbt/StringTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/StringTag.java
similarity index 51%
rename from game/core/src/main/java/com/mojang/nbt/StringTag.java
rename to util/nbt/src/main/java/com/mojang/nbt/tags/StringTag.java
index 172d2944e..2972ac776 100644
--- a/game/core/src/main/java/com/mojang/nbt/StringTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/StringTag.java
@@ -1,33 +1,31 @@
-package com.mojang.nbt;
+package com.mojang.nbt.tags;
+
+import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
+import java.util.Objects;
 
-public class StringTag extends Tag<String>
+public class StringTag extends Tag<@NotNull String>
 {
 
     public StringTag()
     {
-        setValue("");
+        this("");
     }
 
-    public StringTag(String value)
-    {
-        super(value);
-        if(value == null)
-        {
-            throw new IllegalArgumentException("Empty string not allowed");
-        }
+    public StringTag(@NotNull String value) {
+        super(Objects.requireNonNull(value, "Null string not allowed!"));
     }
 
     @Override
-    void write(DataOutput dos)
+    void write(@NotNull DataOutput dos)
         throws IOException
     {
         dos.writeUTF(getValue());
     }
 
     @Override
-    void read(DataInput dis)
+    void read(@NotNull DataInput dis)
         throws IOException
     {
         setValue(dis.readUTF());
@@ -36,7 +34,7 @@ public class StringTag extends Tag<String>
     @Override
     public byte getId()
     {
-        return 8;
+        return TAG_STRING;
     }
 
     @Override
diff --git a/util/nbt/src/main/java/com/mojang/nbt/tags/Tag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/Tag.java
new file mode 100644
index 000000000..cb2918cfc
--- /dev/null
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/Tag.java
@@ -0,0 +1,279 @@
+package com.mojang.nbt.tags;
+
+import com.mojang.nbt.UnknownTagException;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.io.*;
+import java.util.List;
+import java.util.Map;
+import java.util.Objects;
+
+public abstract class Tag<T>
+{
+    static final int TAG_END = 0;
+    static final int TAG_BYTE = 1;
+    static final int TAG_SHORT = 2;
+    static final int TAG_INT = 3;
+    static final int TAG_LONG = 4;
+    static final int TAG_FLOAT = 5;
+    static final int TAG_DOUBLE = 6;
+    static final int TAG_BYTE_ARRAY = 7;
+    static final int TAG_STRING = 8;
+    static final int TAG_LIST = 9;
+    static final int TAG_COMPOUND = 10;
+    static final int TAG_SHORT_ARRAY = 11;
+    static final int TAG_DOUBLE_ARRAY = 12;
+    static final int TAG_LONG_ARRAY = 13;
+
+    /**
+     * The key of the tag.
+     */
+    private @Nullable String name = null;
+    /**
+     * The value of the tag.
+     */
+    private T value;
+
+    public Tag() { }
+
+    public Tag(T value)
+    {
+        this.value = value;
+    }
+
+    /**
+     * Reads the contents of the tag from the input stream.
+     * @param dis The stream to read the tag data from.
+     * @throws IOException Thrown if reading from the stream failed.
+     */
+    abstract void read(@NotNull DataInput dis)
+        throws IOException;
+
+    /**
+     * Writes the contents of the tag to the output stream.
+     * @param dos The stream to write the tag data to.
+     * @throws IOException Thrown if writing to the stream failed.
+     */
+    abstract void write(@NotNull DataOutput dos)
+        throws IOException;
+
+    /**
+     * Fetches the ID of the tag's type.
+     * @return The ID of the tag's type.
+     */
+    public abstract byte getId();
+
+    /**
+     * Fetches the tag's name.
+     * @return The tag's name.
+     */
+    public @NotNull String getTagName()
+    {
+        return name == null ? "" : name;
+    }
+
+    /**
+     * Sets the tag's key.
+     * @param key The new key of the tag.
+     * @return The tag that had its key set.
+     */
+    public @NotNull Tag<T> setName(String key)
+    {
+        this.name = key;
+        return this;
+    }
+
+    /**
+     * Fetches the tag's value.
+     * @return The tag's value.
+     */
+    public T getValue()
+    {
+        return value;
+    }
+
+    /**
+     * Sets the tag's value.
+     * @param value The new value of the tag.
+     * @return The tag that had its value set.
+     */
+    public @NotNull Tag<T> setValue(T value)
+    {
+        this.value = value;
+        return this;
+    }
+
+    /**
+     * Reads a tag from the input stream.
+     * @param dis The stream to read a tag from.
+     * @return The tag read from the stream.
+     * @throws IOException Thrown if reading from the stream failed.
+     */
+    @SuppressWarnings("unused")
+    public static Tag<?> readNamedTag(@NotNull DataInput dis)
+        throws IOException
+    {
+        byte typeId = dis.readByte();
+
+        if(typeId == TAG_END) {
+            return new EndTag();
+        }
+        try {
+            Tag<?> tag = newTag(typeId);
+            tag.name = dis.readUTF();
+            tag.read(dis);
+            return tag;
+        } catch (IllegalArgumentException illegalArgumentException) {
+            throw new UnknownTagException("Unknown tag type '" + typeId + "'!");
+        }
+    }
+
+    /**
+     * Writes a tag to the output stream.
+     * @param tag The tag to write to the stream.
+     * @param dos The stream to write to.
+     * @throws IOException Thrown if writing to the stream failed.
+     */
+    @SuppressWarnings("unused")
+    public static void writeNamedTag(@NotNull Tag<?> tag, @NotNull DataOutput dos)
+        throws IOException
+    {
+        dos.writeByte(tag.getId());
+        if(tag.getId() != TAG_END)
+        {
+            dos.writeUTF(tag.getTagName());
+            tag.write(dos);
+        }
+    }
+
+    @Override
+    public boolean equals(Object obj) {
+        if(!(obj instanceof Tag<?>)) return false;
+        Tag<?> tag = (Tag<?>) obj;
+        return Objects.equals(getValue(), tag.getValue());
+    }
+
+    /**
+     * Creates a new tag wrapping the specified type.
+     * @param type The type to wrap.
+     * @return The wrapped type, or null if no such wrapper exists or is possible.
+     */
+    @SuppressWarnings({"unchecked", "unused"})
+    public static @NotNull <T> Tag<T> createTagOfType(@NotNull Class<T> type)
+    {
+        if (type.isArray()) {
+            Class<?> arrayType = type.getComponentType();
+            if (arrayType == Byte.class || arrayType == byte.class) {
+                return (Tag<T>) new ByteArrayTag();
+            } else if (arrayType == Short.class || arrayType == short.class) {
+                return (Tag<T>) new ShortArrayTag();
+            } else if (arrayType == Long.class || arrayType == long.class) {
+                return (Tag<T>) new LongArrayTag();
+            } else if (arrayType == Double.class || arrayType == double.class) {
+                return (Tag<T>) new DoubleArrayTag();
+            }
+            throw new IllegalArgumentException("No NBT Tag type for array of '" + arrayType + "'!");
+        } else if (type == Byte.class || type == byte.class) {
+            return (Tag<T>) new ByteTag();
+        } else if (type == Short.class || type == short.class) {
+            return (Tag<T>) new ShortTag();
+        } else if (type == Integer.class || type == int.class) {
+            return (Tag<T>) new IntTag();
+        } else if (type == Long.class || type == long.class) {
+            return (Tag<T>) new LongTag();
+        } else if (type == Float.class || type == float.class) {
+            return (Tag<T>) new FloatTag();
+        } else if (type == Double.class || type == double.class) {
+            return (Tag<T>) new DoubleTag();
+        } else if (type == String.class) {
+            return (Tag<T>) new StringTag();
+        } else if (List.class.isAssignableFrom(type)) {
+            return (Tag<T>) new ListTag();
+        } else if (Map.class.isAssignableFrom(type)) {
+            return (Tag<T>) new CompoundTag();
+        }
+        throw new IllegalArgumentException("No NBT Tag type for type '" + type + "'!");
+    }
+
+    /**
+     * Creates a tag according to the given type ID.
+     * @param type The ID of the type of tag to create.
+     * @return The created tag, or null if the type ID doesn't match any tag types.
+     */
+    @SuppressWarnings("unused")
+    public static @NotNull Tag<?> newTag(byte type) {
+        switch (type) {
+            case TAG_END:
+                return new EndTag();
+            case TAG_BYTE:
+                return new ByteTag();
+            case TAG_SHORT:
+                return new ShortTag();
+            case TAG_INT:
+                return new IntTag();
+            case TAG_LONG:
+                return new LongTag();
+            case TAG_FLOAT:
+                return new FloatTag();
+            case TAG_DOUBLE:
+                return new DoubleTag();
+            case TAG_BYTE_ARRAY:
+                return new ByteArrayTag();
+            case TAG_STRING:
+                return new StringTag();
+            case TAG_LIST:
+                return new ListTag();
+            case TAG_COMPOUND:
+                return new CompoundTag();
+            case TAG_SHORT_ARRAY:
+                return new ShortArrayTag();
+            case TAG_DOUBLE_ARRAY:
+                return new DoubleArrayTag();
+            case TAG_LONG_ARRAY:
+                return new LongArrayTag();
+        }
+        throw new IllegalArgumentException("No NBT Tag type for type '" + type + "'!");
+    }
+
+    /**
+     * Gets a string representing a tag's type.
+     * @param type The type ID corresponding to the type of tag.
+     * @return A string representing the tag type ID.
+     */
+    @SuppressWarnings("unused")
+    public static @NotNull String getTagName(byte type)
+    {
+        switch (type) {
+            case TAG_END:
+                return "TAG_End";
+            case TAG_BYTE:
+                return "TAG_Byte";
+            case TAG_SHORT:
+                return "TAG_Short";
+            case TAG_INT:
+                return "TAG_Int";
+            case TAG_LONG:
+                return "TAG_Long";
+            case TAG_FLOAT:
+                return "TAG_Float";
+            case TAG_DOUBLE:
+                return "TAG_Double";
+            case TAG_BYTE_ARRAY:
+                return "TAG_Byte_Array";
+            case TAG_STRING:
+                return "TAG_String";
+            case TAG_LIST:
+                return "TAG_List";
+            case TAG_COMPOUND:
+                return "TAG_Compound";
+            case TAG_SHORT_ARRAY:
+                return "TAG_Short_Array";
+            case TAG_DOUBLE_ARRAY:
+                return "TAG_Double_Array";
+            case TAG_LONG_ARRAY:
+                return "TAG_Long_Array";
+        }
+        throw new IllegalArgumentException("No NBT Tag type for type '" + type + "'!");
+    }
+}
diff --git a/util/nbt/src/test/java/TestByteArrayTag.java b/util/nbt/src/test/java/TestByteArrayTag.java
new file mode 100644
index 000000000..704652bc9
--- /dev/null
+++ b/util/nbt/src/test/java/TestByteArrayTag.java
@@ -0,0 +1,21 @@
+import com.mojang.nbt.tags.ByteArrayTag;
+import org.junit.jupiter.api.Assertions;
+import org.junit.jupiter.api.Test;
+
+public class TestByteArrayTag {
+    @Test
+    public void testTag() {
+        ByteArrayTag byteArrayTagEmpty = new ByteArrayTag();
+        Assertions.assertEquals(byteArrayTagEmpty.getId(), 7, "Tag id does not match its expected id!");
+        Assertions.assertArrayEquals(new byte[0], byteArrayTagEmpty.getValue(), "Default byte array tag value should be and empty array!");
+
+        ByteArrayTag byteArrayTag1 = new ByteArrayTag(new byte[]{-1, 0, 2, 7, 9, Byte.MAX_VALUE, Byte.MIN_VALUE});
+        Assertions.assertArrayEquals(new byte[]{-1, 0, 2, 7, 9, Byte.MAX_VALUE, Byte.MIN_VALUE}, byteArrayTag1.getValue(), "Tag value does not match its equivalent array!");
+
+        ByteArrayTag byteArrayTag2 = new ByteArrayTag(new byte[]{-1, 0, 2, 7, 9, Byte.MAX_VALUE, Byte.MIN_VALUE});
+        Assertions.assertEquals(byteArrayTag2, byteArrayTag1, "Tag value does not equal its equivalent tag!");
+
+        ByteArrayTag byteArrayTag3 = new ByteArrayTag(new byte[]{Byte.MIN_VALUE, Byte.MAX_VALUE, 9, 7, 2, 0, -1});
+        Assertions.assertNotEquals(byteArrayTag3, byteArrayTag2, "Tag equals non equivalent tag!");
+    }
+}
diff --git a/util/nbt/src/test/java/TestByteTag.java b/util/nbt/src/test/java/TestByteTag.java
new file mode 100644
index 000000000..a37057e58
--- /dev/null
+++ b/util/nbt/src/test/java/TestByteTag.java
@@ -0,0 +1,21 @@
+import com.mojang.nbt.tags.ByteTag;
+import org.junit.jupiter.api.Assertions;
+import org.junit.jupiter.api.Test;
+
+public class TestByteTag {
+    @Test
+    public void testTag() {
+        ByteTag byteTagEmpty = new ByteTag();
+        Assertions.assertEquals(byteTagEmpty.getId(), 1, "Tag id does not match its expected id!");
+        Assertions.assertEquals(byteTagEmpty.getValue(), (byte) 0, "Default byte tag value should be 0!");
+
+        ByteTag byteTag1 = new ByteTag(Byte.MAX_VALUE);
+        Assertions.assertEquals(Byte.MAX_VALUE, byteTag1.getValue(), "Tag value does not match its equivalent value!");
+
+        ByteTag byteTag2 = new ByteTag(Byte.MAX_VALUE);
+        Assertions.assertEquals(byteTag2, byteTag1, "Tag value does not equal its equivalent tag!");
+
+        ByteTag byteTag3 = new ByteTag(Byte.MIN_VALUE);
+        Assertions.assertNotEquals(byteTag3, byteTag2, "Tag equals non equivalent tag!");
+    }
+}
